Index: LMDZ6/branches/Amaury_dev/libf/phylmd/conlmd.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/conlmd.F90	(revision 5142)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/conlmd.F90	(revision 5143)
@@ -1,8 +1,9 @@
-
 ! $Header$
 
 SUBROUTINE conlmd(dtime, paprs, pplay, t, q, conv_q, d_t, d_q, rain, snow, &
-    ibas, itop)
+        ibas, itop)
   USE dimphy
+  USE lmdz_YOETHF
+
   IMPLICIT NONE
   ! ======================================================================
@@ -12,10 +13,9 @@
   ! ======================================================================
   include "YOMCST.h"
-  include "YOETHF.h"
 
   ! Arguments:
 
   REAL dtime ! pas d'integration (s)
-  REAL paprs(klon, klev+1) ! pression inter-couche (Pa)
+  REAL paprs(klon, klev + 1) ! pression inter-couche (Pa)
   REAL pplay(klon, klev) ! pression au milieu de couche (Pa)
   REAL t(klon, klev) ! temperature (K)
@@ -31,5 +31,5 @@
 
   LOGICAL usekuo ! utiliser convection profonde (schema Kuo)
-  PARAMETER (usekuo=.TRUE.)
+  PARAMETER (usekuo = .TRUE.)
 
   REAL d_t_bis(klon, klev)
@@ -47,13 +47,13 @@
   ! cc      CALL fiajh ! ancienne version de Convection Manabe
   CALL conman &                    ! nouvelle version de Convection
-                                   ! Manabe
-    (dtime, paprs, pplay, t, q, d_t, d_q, d_ql, rneb, rain, snow, ibas, itop)
+          ! Manabe
+          (dtime, paprs, pplay, t, q, d_t, d_q, d_ql, rneb, rain, snow, ibas, itop)
 
   IF (usekuo) THEN
     ! cc      CALL fiajc ! ancienne version de Convection Kuo
     CALL conkuo &                  ! nouvelle version de Convection
-                                   ! Kuo
-      (dtime, paprs, pplay, t, q, conv_q, d_t_bis, d_q_bis, d_ql_bis, &
-      rneb_bis, rain_bis, snow_bis, ibas_bis, itop_bis)
+            ! Kuo
+            (dtime, paprs, pplay, t, q, conv_q, d_t_bis, d_q_bis, d_ql_bis, &
+            rneb_bis, rain_bis, snow_bis, ibas_bis, itop_bis)
     DO k = 1, klev
       DO i = 1, klon
@@ -75,10 +75,10 @@
   DO k = 1, klev
     DO i = 1, klon
-      zlvdcp = rlvtt/rcpd/(1.0+rvtmp2*q(i,k))
-      zlsdcp = rlstt/rcpd/(1.0+rvtmp2*q(i,k))
-      zdelta = max(0., sign(1.,rtt-t(i,k)))
+      zlvdcp = rlvtt / rcpd / (1.0 + rvtmp2 * q(i, k))
+      zlsdcp = rlstt / rcpd / (1.0 + rvtmp2 * q(i, k))
+      zdelta = max(0., sign(1., rtt - t(i, k)))
       zz = d_ql(i, k) ! re-evap. de l'eau liquide
       zb = max(0.0, zz)
-      za = -max(0.0, zz)*(zlvdcp*(1.-zdelta)+zlsdcp*zdelta)
+      za = -max(0.0, zz) * (zlvdcp * (1. - zdelta) + zlsdcp * zdelta)
       d_t(i, k) = d_t(i, k) + za
       d_q(i, k) = d_q(i, k) + zb
@@ -86,9 +86,11 @@
   END DO
 
-
 END SUBROUTINE conlmd
 SUBROUTINE conman(dtime, paprs, pplay, t, q, d_t, d_q, d_ql, rneb, rain, &
-    snow, ibas, itop)
+        snow, ibas, itop)
   USE dimphy
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
   IMPLICIT NONE
   ! ======================================================================
@@ -108,5 +110,5 @@
   REAL t(klon, klev) ! temperature (K)
   REAL q(klon, klev) ! humidite specifique (kg/kg)
-  REAL paprs(klon, klev+1) ! pression inter-couche (Pa)
+  REAL paprs(klon, klev + 1) ! pression inter-couche (Pa)
   REAL pplay(klon, klev) ! pression au milieu de couche (Pa)
 
@@ -124,9 +126,9 @@
 
   INTEGER nb ! nombre de sous-fractions a considere
-  PARAMETER (nb=1)
+  PARAMETER (nb = 1)
   ! cc      PARAMETER (nb=3)
 
   REAL ratqs ! largeur de la distribution pour vapeur d'eau
-  PARAMETER (ratqs=0.05)
+  PARAMETER (ratqs = 0.05)
 
   REAL w_q(klon, klev)
@@ -139,5 +141,5 @@
 
   REAL t_coup
-  PARAMETER (t_coup=234.0)
+  PARAMETER (t_coup = 234.0)
   REAL zdp1, zdp2
   REAL zqs1, zqs2, zdqs1, zdqs2
@@ -163,7 +165,4 @@
   ! Fonctions thermodynamiques:
 
-  include "YOETHF.h"
-  include "FCTTRE.h"
-
   DATA frac/1.0/
   DATA opt_cld/4/
@@ -207,43 +206,43 @@
     DO i = 1, klon
       IF (thermcep) THEN
-        zdelta = max(0., sign(1.,rtt-t(i,k)))
-        zcvm5 = r5les*rlvtt*(1.-zdelta) + zdelta*r5ies*rlstt
-        zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*q(i,k))
-        zqs1 = r2es*foeew(t(i,k), zdelta)/pplay(i, k)
+        zdelta = max(0., sign(1., rtt - t(i, k)))
+        zcvm5 = r5les * rlvtt * (1. - zdelta) + zdelta * r5ies * rlstt
+        zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * q(i, k))
+        zqs1 = r2es * foeew(t(i, k), zdelta) / pplay(i, k)
         zqs1 = min(0.5, zqs1)
-        zcor = 1./(1.-retv*zqs1)
-        zqs1 = zqs1*zcor
-        zdqs1 = foede(t(i,k), zdelta, zcvm5, zqs1, zcor)
-
-        zdelta = max(0., sign(1.,rtt-t(i,k+1)))
-        zcvm5 = r5les*rlvtt*(1.-zdelta) + zdelta*r5ies*rlstt
-        zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*q(i,k+1))
-        zqs2 = r2es*foeew(t(i,k+1), zdelta)/pplay(i, k+1)
+        zcor = 1. / (1. - retv * zqs1)
+        zqs1 = zqs1 * zcor
+        zdqs1 = foede(t(i, k), zdelta, zcvm5, zqs1, zcor)
+
+        zdelta = max(0., sign(1., rtt - t(i, k + 1)))
+        zcvm5 = r5les * rlvtt * (1. - zdelta) + zdelta * r5ies * rlstt
+        zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * q(i, k + 1))
+        zqs2 = r2es * foeew(t(i, k + 1), zdelta) / pplay(i, k + 1)
         zqs2 = min(0.5, zqs2)
-        zcor = 1./(1.-retv*zqs2)
-        zqs2 = zqs2*zcor
-        zdqs2 = foede(t(i,k+1), zdelta, zcvm5, zqs2, zcor)
+        zcor = 1. / (1. - retv * zqs2)
+        zqs2 = zqs2 * zcor
+        zdqs2 = foede(t(i, k + 1), zdelta, zcvm5, zqs2, zcor)
       ELSE
-        IF (t(i,k)<t_coup) THEN
-          zqs1 = qsats(t(i,k))/pplay(i, k)
-          zdqs1 = dqsats(t(i,k), zqs1)
-
-          zqs2 = qsats(t(i,k+1))/pplay(i, k+1)
-          zdqs2 = dqsats(t(i,k+1), zqs2)
+        IF (t(i, k)<t_coup) THEN
+          zqs1 = qsats(t(i, k)) / pplay(i, k)
+          zdqs1 = dqsats(t(i, k), zqs1)
+
+          zqs2 = qsats(t(i, k + 1)) / pplay(i, k + 1)
+          zdqs2 = dqsats(t(i, k + 1), zqs2)
         ELSE
-          zqs1 = qsatl(t(i,k))/pplay(i, k)
-          zdqs1 = dqsatl(t(i,k), zqs1)
-
-          zqs2 = qsatl(t(i,k+1))/pplay(i, k+1)
-          zdqs2 = dqsatl(t(i,k+1), zqs2)
-        END IF
-      END IF
-      zdp1 = paprs(i, k) - paprs(i, k+1)
-      zdp2 = paprs(i, k+1) - paprs(i, k+2)
-      zgamdz = -(pplay(i,k)-pplay(i,k+1))/paprs(i, k+1)/rcpd*(rd*(t(i, &
-        k)*zdp1+t(i,k+1)*zdp2)/(zdp1+zdp2)+rlvtt*(zqs1*zdp1+zqs2*zdp2)/(zdp1+ &
-        zdp2))/(1.0+(zdqs1*zdp1+zdqs2*zdp2)/(zdp1+zdp2))
-      zflo = t(i, k) + zgamdz - t(i, k+1)
-      zsat = (q(i,k)-zqs1)*zdp1 + (q(i,k+1)-zqs2)*zdp2
+          zqs1 = qsatl(t(i, k)) / pplay(i, k)
+          zdqs1 = dqsatl(t(i, k), zqs1)
+
+          zqs2 = qsatl(t(i, k + 1)) / pplay(i, k + 1)
+          zdqs2 = dqsatl(t(i, k + 1), zqs2)
+        END IF
+      END IF
+      zdp1 = paprs(i, k) - paprs(i, k + 1)
+      zdp2 = paprs(i, k + 1) - paprs(i, k + 2)
+      zgamdz = -(pplay(i, k) - pplay(i, k + 1)) / paprs(i, k + 1) / rcpd * (rd * (t(i, &
+              k) * zdp1 + t(i, k + 1) * zdp2) / (zdp1 + zdp2) + rlvtt * (zqs1 * zdp1 + zqs2 * zdp2) / (zdp1 + &
+              zdp2)) / (1.0 + (zdqs1 * zdp1 + zdqs2 * zdp2) / (zdp1 + zdp2))
+      zflo = t(i, k) + zgamdz - t(i, k + 1)
+      zsat = (q(i, k) - zqs1) * zdp1 + (q(i, k + 1) - zqs2) * zdp2
       IF (zflo>0.0) afaire(i) = .TRUE.
       ! erreur         IF (zflo.GT.0.0 .AND. zsat.GT.0.0) afaire(i) = .TRUE.
@@ -257,7 +256,7 @@
       DO i = 1, klon
         IF (afaire(i)) THEN
-          zq1 = q(i, k)*(1.0-ratqs)
-          zq2 = q(i, k)*(1.0+ratqs)
-          w_q(i, k) = zq2 - frac(n)/2.0*(zq2-zq1)
+          zq1 = q(i, k) * (1.0 - ratqs)
+          zq2 = q(i, k) * (1.0 + ratqs)
+          w_q(i, k) = zq2 - frac(n) / 2.0 * (zq2 - zq1)
         END IF
       END DO
@@ -265,13 +264,13 @@
 
     CALL conmanv(dtime, paprs, pplay, t, w_q, afaire, opt_cld(n), w_d_t, &
-      w_d_q, w_d_ql, w_rneb, w_rain, w_snow, w_ibas, w_itop, accompli, &
-      imprim)
+            w_d_q, w_d_ql, w_rneb, w_rain, w_snow, w_ibas, w_itop, accompli, &
+            imprim)
     DO k = 1, klev
       DO i = 1, klon
         IF (afaire(i) .AND. accompli(i)) THEN
-          d_t(i, k) = w_d_t(i, k)*frac(n)
-          d_q(i, k) = w_d_q(i, k)*frac(n)
-          d_ql(i, k) = w_d_ql(i, k)*frac(n)
-          IF (nint(w_rneb(i,k))==1) rneb(i, k) = frac(n)
+          d_t(i, k) = w_d_t(i, k) * frac(n)
+          d_q(i, k) = w_d_q(i, k) * frac(n)
+          d_ql(i, k) = w_d_ql(i, k) * frac(n)
+          IF (nint(w_rneb(i, k))==1) rneb(i, k) = frac(n)
         END IF
       END DO
@@ -279,6 +278,6 @@
     DO i = 1, klon
       IF (afaire(i) .AND. accompli(i)) THEN
-        rain(i) = w_rain(i)*frac(n)
-        snow(i) = w_snow(i)*frac(n)
+        rain(i) = w_rain(i) * frac(n)
+        snow(i) = w_snow(i) * frac(n)
         ibas(i) = min(ibas(i), w_ibas(i))
         itop(i) = max(itop(i), w_itop(i))
@@ -293,9 +292,11 @@
   ncpt = ncpt + 1
 
-
 END SUBROUTINE conman
 SUBROUTINE conmanv(dtime, paprs, pplay, t, q, afaire, opt_cld, d_t, d_q, &
-    d_ql, rneb, rain, snow, ibas, itop, accompli, imprim)
+        d_ql, rneb, rain, snow, ibas, itop, accompli, imprim)
   USE dimphy
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
   IMPLICIT NONE
   ! ======================================================================
@@ -313,5 +314,5 @@
   REAL t(klon, klev) ! temperature (K)
   REAL q(klon, klev) ! humidite specifique (kg/kg)
-  REAL paprs(klon, klev+1) ! pression inter-couche (Pa)
+  REAL paprs(klon, klev + 1) ! pression inter-couche (Pa)
   REAL pplay(klon, klev) ! pression au milieu de couche (Pa)
   INTEGER opt_cld ! comment traiter l'eau liquide
@@ -332,27 +333,27 @@
 
   LOGICAL new_top ! re-calculer sommet quand re-ajustement est fait
-  PARAMETER (new_top=.FALSE.)
+  PARAMETER (new_top = .FALSE.)
   LOGICAL evap_prec ! evaporation de pluie au-dessous de convection
-  PARAMETER (evap_prec=.TRUE.)
+  PARAMETER (evap_prec = .TRUE.)
   REAL coef_eva
-  PARAMETER (coef_eva=1.0E-05)
+  PARAMETER (coef_eva = 1.0E-05)
   REAL t_coup
-  PARAMETER (t_coup=234.0)
+  PARAMETER (t_coup = 234.0)
   REAL seuil_vap
-  PARAMETER (seuil_vap=1.0E-10)
+  PARAMETER (seuil_vap = 1.0E-10)
   LOGICAL old_tau ! implique precip nulle, si vrai.
-  PARAMETER (old_tau=.FALSE.)
+  PARAMETER (old_tau = .FALSE.)
   REAL toliq(klon) ! rapport entre l'eau nuageuse et l'eau precipitante
   REAL dpmin, tomax !Epaisseur faible, rapport eau liquide plus grande
-  PARAMETER (dpmin=0.15, tomax=0.97)
+  PARAMETER (dpmin = 0.15, tomax = 0.97)
   REAL dpmax, tomin !Epaisseur grande, rapport eau liquide plus faible
-  PARAMETER (dpmax=0.30, tomin=0.05)
+  PARAMETER (dpmax = 0.30, tomin = 0.05)
   REAL deep_sig, deep_to ! au dela de deep_sig, utiliser deep_to
-  PARAMETER (deep_sig=0.50, deep_to=0.05)
+  PARAMETER (deep_sig = 0.50, deep_to = 0.05)
   LOGICAL exigent ! implique un calcul supplementaire pour Qs
-  PARAMETER (exigent=.FALSE.)
+  PARAMETER (exigent = .FALSE.)
 
   INTEGER kbase
-  PARAMETER (kbase=0)
+  PARAMETER (kbase = 0)
 
   ! Variables locales:
@@ -360,5 +361,5 @@
   INTEGER nexpo
   INTEGER i, k, k1min, k1max, k2min, k2max, is
-  REAL zgamdz(klon, klev-1)
+  REAL zgamdz(klon, klev - 1)
   REAL zt(klon, klev), zq(klon, klev)
   REAL zqs(klon, klev), zdqs(klon, klev)
@@ -380,10 +381,7 @@
   ! Fonctions thermodynamiques:
 
-  include "YOETHF.h"
-  include "FCTTRE.h"
-
   DO k = 1, klev
     DO i = 1, klon
-      delp(i, k) = paprs(i, k) - paprs(i, k+1)
+      delp(i, k) = paprs(i, k) - paprs(i, k + 1)
     END DO
   END DO
@@ -418,24 +416,24 @@
 
         IF (thermcep) THEN
-          zdelta = max(0., sign(1.,rtt-zt(i,k)))
-          zcvm5 = r5les*rlvtt*(1.-zdelta) + zdelta*r5ies*rlstt
-          zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*zq(i,k))
-          zqs(i, k) = r2es*foeew(zt(i,k), zdelta)/pplay(i, k)
-          zqs(i, k) = min(0.5, zqs(i,k))
-          zcor = 1./(1.-retv*zqs(i,k))
-          zqs(i, k) = zqs(i, k)*zcor
-          zdqs(i, k) = foede(zt(i,k), zdelta, zcvm5, zqs(i,k), zcor)
+          zdelta = max(0., sign(1., rtt - zt(i, k)))
+          zcvm5 = r5les * rlvtt * (1. - zdelta) + zdelta * r5ies * rlstt
+          zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * zq(i, k))
+          zqs(i, k) = r2es * foeew(zt(i, k), zdelta) / pplay(i, k)
+          zqs(i, k) = min(0.5, zqs(i, k))
+          zcor = 1. / (1. - retv * zqs(i, k))
+          zqs(i, k) = zqs(i, k) * zcor
+          zdqs(i, k) = foede(zt(i, k), zdelta, zcvm5, zqs(i, k), zcor)
         ELSE
-          IF (zt(i,k)<t_coup) THEN
-            zqs(i, k) = qsats(zt(i,k))/pplay(i, k)
-            zdqs(i, k) = dqsats(zt(i,k), zqs(i,k))
+          IF (zt(i, k)<t_coup) THEN
+            zqs(i, k) = qsats(zt(i, k)) / pplay(i, k)
+            zdqs(i, k) = dqsats(zt(i, k), zqs(i, k))
           ELSE
-            zqs(i, k) = qsatl(zt(i,k))/pplay(i, k)
-            zdqs(i, k) = dqsatl(zt(i,k), zqs(i,k))
+            zqs(i, k) = qsatl(zt(i, k)) / pplay(i, k)
+            zdqs(i, k) = dqsatl(zt(i, k), zqs(i, k))
           END IF
         END IF
 
         ! Calculer (q-qs)*dp
-        zqmqsdp(i, k) = (zq(i,k)-zqs(i,k))*delp(i, k)
+        zqmqsdp(i, k) = (zq(i, k) - zqs(i, k)) * delp(i, k)
       END IF
     END DO
@@ -450,9 +448,9 @@
     DO i = 1, klon
       IF (afaire(i)) THEN
-        zgamdz(i, k) = -(pplay(i,k)-pplay(i,k+1))/paprs(i, k+1)/rcpd*(rd*(zt( &
-          i,k)*delp(i,k)+zt(i,k+1)*delp(i,k+1))/(delp(i,k)+delp(i, &
-          k+1))+rlvtt*(zqs(i,k)*delp(i,k)+zqs(i,k+1)*delp(i,k+1))/(delp(i, &
-          k)+delp(i,k+1)))/(1.0+(zdqs(i,k)*delp(i,k)+zdqs(i,k+1)*delp(i, &
-          k+1))/(delp(i,k)+delp(i,k+1)))
+        zgamdz(i, k) = -(pplay(i, k) - pplay(i, k + 1)) / paprs(i, k + 1) / rcpd * (rd * (zt(&
+                i, k) * delp(i, k) + zt(i, k + 1) * delp(i, k + 1)) / (delp(i, k) + delp(i, &
+                k + 1)) + rlvtt * (zqs(i, k) * delp(i, k) + zqs(i, k + 1) * delp(i, k + 1)) / (delp(i, &
+                k) + delp(i, k + 1))) / (1.0 + (zdqs(i, k) * delp(i, k) + zdqs(i, k + 1) * delp(i, &
+                k + 1)) / (delp(i, k) + delp(i, k + 1)))
       END IF
     END DO
@@ -468,6 +466,6 @@
     DO i = 1, klon
       IF (afaire(i)) THEN
-        zflo(i) = zt(i, k-1) + zgamdz(i, k-1) - zt(i, k)
-        zsat(i) = zqmqsdp(i, k) + zqmqsdp(i, k-1)
+        zflo(i) = zt(i, k - 1) + zgamdz(i, k - 1) - zt(i, k)
+        zsat(i) = zqmqsdp(i, k) + zqmqsdp(i, k - 1)
         IF (zflo(i)>0.0 .AND. zsat(i)>0.0) possible(i) = .TRUE.
       END IF
@@ -482,5 +480,5 @@
   END DO
 
-810 CONTINUE ! chercher le bas de la colonne a ajuster
+  810 CONTINUE ! chercher le bas de la colonne a ajuster
 
   k2min = klev
@@ -494,6 +492,6 @@
     DO i = 1, klon
       IF (possible(i) .AND. k>=k2(i) .AND. aller(i)) THEN
-        zflo(i) = zt(i, k) + zgamdz(i, k) - zt(i, k+1)
-        zsat(i) = zqmqsdp(i, k) + zqmqsdp(i, k+1)
+        zflo(i) = zt(i, k) + zgamdz(i, k) - zt(i, k + 1)
+        zsat(i) = zqmqsdp(i, k) + zqmqsdp(i, k + 1)
         IF (zflo(i)>0.0 .AND. zsat(i)>0.0) THEN
           k1(i) = k
@@ -530,5 +528,5 @@
   ! CC      ENDDO
 
-820 CONTINUE ! chercher le haut de la colonne
+  820 CONTINUE ! chercher le haut de la colonne
 
   k2min = klev
@@ -542,5 +540,5 @@
         IF (todo(i) .AND. k>k2(i) .AND. aller(i)) THEN
           zsat(i) = zsat(i) + zqmqsdp(i, k)
-          zflo(i) = zt(i, k-1) + zgamdz(i, k-1) - zt(i, k)
+          zflo(i) = zt(i, k - 1) + zgamdz(i, k - 1) - zt(i, k)
           IF (zflo(i)<=0.0 .OR. zsat(i)<=0.0) THEN
             aller(i) = .FALSE.
@@ -579,5 +577,5 @@
   ! CC      ENDDO
 
-830 CONTINUE ! faire l'ajustement en sachant k1 et k2
+  830 CONTINUE ! faire l'ajustement en sachant k1 et k2
 
   is = 0
@@ -608,7 +606,7 @@
       k = k1(i)
       za(i) = 0.
-      zb(i) = (rcpd*(1.+zdqs(i,k))*(zt(i,k)-za(i))-rlvtt*(zqs(i,k)-zq(i, &
-        k)))*delp(i, k)
-      zc(i) = delp(i, k)*rcpd*(1.+zdqs(i,k))
+      zb(i) = (rcpd * (1. + zdqs(i, k)) * (zt(i, k) - za(i)) - rlvtt * (zqs(i, k) - zq(i, &
+              k))) * delp(i, k)
+      zc(i) = delp(i, k) * rcpd * (1. + zdqs(i, k))
     END IF
   END DO
@@ -616,9 +614,9 @@
   DO k = k1min, k2max
     DO i = 1, klon
-      IF (todo(i) .AND. k>=(k1(i)+1) .AND. k<=k2(i)) THEN
-        za(i) = za(i) + zgamdz(i, k-1)
-        zb(i) = zb(i) + (rcpd*(1.+zdqs(i,k))*(zt(i,k)-za(i))-rlvtt*(zqs(i, &
-          k)-zq(i,k)))*delp(i, k)
-        zc(i) = zc(i) + delp(i, k)*rcpd*(1.+zdqs(i,k))
+      IF (todo(i) .AND. k>=(k1(i) + 1) .AND. k<=k2(i)) THEN
+        za(i) = za(i) + zgamdz(i, k - 1)
+        zb(i) = zb(i) + (rcpd * (1. + zdqs(i, k)) * (zt(i, k) - za(i)) - rlvtt * (zqs(i, &
+                k) - zq(i, k))) * delp(i, k)
+        zc(i) = zc(i) + delp(i, k) * rcpd * (1. + zdqs(i, k))
       END IF
     END DO
@@ -628,6 +626,6 @@
     IF (todo(i)) THEN
       k = k1(i)
-      ztnew(i, k) = zb(i)/zc(i)
-      zqnew(i, k) = zqs(i, k) + (ztnew(i,k)-zt(i,k))*rcpd/rlvtt*zdqs(i, k)
+      ztnew(i, k) = zb(i) / zc(i)
+      zqnew(i, k) = zqs(i, k) + (ztnew(i, k) - zt(i, k)) * rcpd / rlvtt * zdqs(i, k)
     END IF
   END DO
@@ -635,7 +633,7 @@
   DO k = k1min, k2max
     DO i = 1, klon
-      IF (todo(i) .AND. k>=(k1(i)+1) .AND. k<=k2(i)) THEN
-        ztnew(i, k) = ztnew(i, k-1) + zgamdz(i, k-1)
-        zqnew(i, k) = zqs(i, k) + (ztnew(i,k)-zt(i,k))*rcpd/rlvtt*zdqs(i, k)
+      IF (todo(i) .AND. k>=(k1(i) + 1) .AND. k<=k2(i)) THEN
+        ztnew(i, k) = ztnew(i, k - 1) + zgamdz(i, k - 1)
+        zqnew(i, k) = zqs(i, k) + (ztnew(i, k) - zt(i, k)) * rcpd / rlvtt * zdqs(i, k)
       END IF
     END DO
@@ -651,5 +649,5 @@
       IF (todo(i) .AND. k>=k1(i) .AND. k<=k2(i)) THEN
         rneb(i, k) = 1.0
-        zcond(i) = zcond(i) + (zq(i,k)-zqnew(i,k))*delp(i, k)/rg
+        zcond(i) = zcond(i) + (zq(i, k) - zqnew(i, k)) * delp(i, k) / rg
       END IF
     END DO
@@ -680,8 +678,8 @@
   DO i = 1, klon
     IF (todo(i)) THEN
-      toliq(i) = tomax - ((paprs(i,k1(i))-paprs(i,k2(i)+1))/paprs(i,1)-dpmin) &
-        *(tomax-tomin)/(dpmax-dpmin)
-      toliq(i) = max(tomin, min(tomax,toliq(i)))
-      IF (pplay(i,k2(i))/paprs(i,1)<=deep_sig) toliq(i) = deep_to
+      toliq(i) = tomax - ((paprs(i, k1(i)) - paprs(i, k2(i) + 1)) / paprs(i, 1) - dpmin) &
+              * (tomax - tomin) / (dpmax - dpmin)
+      toliq(i) = max(tomin, min(tomax, toliq(i)))
+      IF (pplay(i, k2(i)) / paprs(i, 1)<=deep_sig) toliq(i) = deep_to
       IF (old_tau) toliq(i) = 1.0
     END IF
@@ -706,5 +704,5 @@
 
     DO i = 1, klon
-      IF (todo(i)) zrfl(i) = zcond(i)/dtime
+      IF (todo(i)) zrfl(i) = zcond(i) / dtime
     END DO
 
@@ -717,12 +715,12 @@
       DO i = 1, klon
         IF (todo(i) .AND. k>=k1(i) .AND. k<=k2(i)) zvapo(i) = zvapo(i) + &
-          zqnew(i, k)*delp(i, k)/rg
+                zqnew(i, k) * delp(i, k) / rg
       END DO
     END DO
     DO i = 1, klon
       IF (todo(i)) THEN
-        zrapp(i) = toliq(i)*zcond(i)/zvapo(i)
-        zrapp(i) = max(0., min(1.,zrapp(i)))
-        zrfl(i) = (1.0-toliq(i))*zcond(i)/dtime
+        zrapp(i) = toliq(i) * zcond(i) / zvapo(i)
+        zrapp(i) = max(0., min(1., zrapp(i)))
+        zrfl(i) = (1.0 - toliq(i)) * zcond(i) / dtime
       END IF
     END DO
@@ -730,5 +728,5 @@
       DO i = 1, klon
         IF (todo(i) .AND. k>=k1(i) .AND. k<=k2(i)) THEN
-          d_ql(i, k) = d_ql(i, k) + zrapp(i)*zqnew(i, k)
+          d_ql(i, k) = d_ql(i, k) + zrapp(i) * zqnew(i, k)
         END IF
       END DO
@@ -743,5 +741,5 @@
       DO i = 1, klon
         IF (todo(i) .AND. k>=k1(i) .AND. k<=k2(i)) zvapo(i) = zvapo(i) + &
-          delp(i, k)/rg
+                delp(i, k) / rg
       END DO
     END DO
@@ -749,10 +747,10 @@
       DO i = 1, klon
         IF (todo(i) .AND. k>=k1(i) .AND. k<=k2(i)) THEN
-          d_ql(i, k) = d_ql(i, k) + toliq(i)*zcond(i)/zvapo(i)
-        END IF
-      END DO
-    END DO
-    DO i = 1, klon
-      IF (todo(i)) zrfl(i) = (1.0-toliq(i))*zcond(i)/dtime
+          d_ql(i, k) = d_ql(i, k) + toliq(i) * zcond(i) / zvapo(i)
+        END IF
+      END DO
+    END DO
+    DO i = 1, klon
+      IF (todo(i)) zrfl(i) = (1.0 - toliq(i)) * zcond(i) / dtime
     END DO
 
@@ -765,5 +763,5 @@
       DO i = 1, klon
         IF (todo(i) .AND. k>=k1(i) .AND. k<=k2(i)) zvapo(i) = zvapo(i) + &
-          max(0.0, zq(i,k)-zqnew(i,k))*delp(i, k)/rg
+                max(0.0, zq(i, k) - zqnew(i, k)) * delp(i, k) / rg
       END DO
     END DO
@@ -771,10 +769,10 @@
       DO i = 1, klon
         IF (todo(i) .AND. k>=k1(i) .AND. k<=k2(i) .AND. zvapo(i)>0.0) d_ql(i, &
-          k) = d_ql(i, k) + toliq(i)*zcond(i)/zvapo(i)*max(0.0, zq(i,k)-zqnew &
-          (i,k))
-      END DO
-    END DO
-    DO i = 1, klon
-      IF (todo(i)) zrfl(i) = (1.0-toliq(i))*zcond(i)/dtime
+                k) = d_ql(i, k) + toliq(i) * zcond(i) / zvapo(i) * max(0.0, zq(i, k) - zqnew &
+                (i, k))
+      END DO
+    END DO
+    DO i = 1, klon
+      IF (todo(i)) zrfl(i) = (1.0 - toliq(i)) * zcond(i) / dtime
     END DO
 
@@ -789,16 +787,16 @@
     DO k = k1min, k2max
       DO i = 1, klon
-        IF (todo(i) .AND. k>=(k1(i)+1) .AND. k<=k2(i)) zvapo(i) = zvapo(i) + &
-          delp(i, k)/rg*(pplay(i,k1(i))-pplay(i,k))**nexpo
+        IF (todo(i) .AND. k>=(k1(i) + 1) .AND. k<=k2(i)) zvapo(i) = zvapo(i) + &
+                delp(i, k) / rg * (pplay(i, k1(i)) - pplay(i, k))**nexpo
       END DO
     END DO
     DO k = k1min, k2max
       DO i = 1, klon
-        IF (todo(i) .AND. k>=(k1(i)+1) .AND. k<=k2(i)) d_ql(i, k) = d_ql(i, &
-          k) + toliq(i)*zcond(i)/zvapo(i)*(pplay(i,k1(i))-pplay(i,k))**nexpo
-      END DO
-    END DO
-    DO i = 1, klon
-      IF (todo(i)) zrfl(i) = (1.0-toliq(i))*zcond(i)/dtime
+        IF (todo(i) .AND. k>=(k1(i) + 1) .AND. k<=k2(i)) d_ql(i, k) = d_ql(i, &
+                k) + toliq(i) * zcond(i) / zvapo(i) * (pplay(i, k1(i)) - pplay(i, k))**nexpo
+      END DO
+    END DO
+    DO i = 1, klon
+      IF (todo(i)) zrfl(i) = (1.0 - toliq(i)) * zcond(i) / dtime
     END DO
 
@@ -817,13 +815,13 @@
       DO i = 1, klon
         IF (todo(i) .AND. k<k1(i) .AND. zrfl(i)>0.0) THEN
-          zqev = max(0.0, (zqs(i,k)-zq(i,k))*zalfa)
-          zqevt = coef_eva*(1.0-zq(i,k)/zqs(i,k))*sqrt(zrfl(i))*delp(i, k)/ &
-            pplay(i, k)*zt(i, k)*rd/rg
-          zqevt = max(0.0, min(zqevt,zrfl(i)))*rg*dtime/delp(i, k)
+          zqev = max(0.0, (zqs(i, k) - zq(i, k)) * zalfa)
+          zqevt = coef_eva * (1.0 - zq(i, k) / zqs(i, k)) * sqrt(zrfl(i)) * delp(i, k) / &
+                  pplay(i, k) * zt(i, k) * rd / rg
+          zqevt = max(0.0, min(zqevt, zrfl(i))) * rg * dtime / delp(i, k)
           zqev = min(zqev, zqevt)
-          zrfln = zrfl(i) - zqev*(delp(i,k))/rg/dtime
-          zq(i, k) = zq(i, k) - (zrfln-zrfl(i))*(rg/(delp(i,k)))*dtime
-          zt(i, k) = zt(i, k) + (zrfln-zrfl(i))*(rg/(delp(i, &
-            k)))*dtime*rlvtt/rcpd/(1.0+rvtmp2*zq(i,k))
+          zrfln = zrfl(i) - zqev * (delp(i, k)) / rg / dtime
+          zq(i, k) = zq(i, k) - (zrfln - zrfl(i)) * (rg / (delp(i, k))) * dtime
+          zt(i, k) = zt(i, k) + (zrfln - zrfl(i)) * (rg / (delp(i, &
+                  k))) * dtime * rlvtt / rcpd / (1.0 + rvtmp2 * zq(i, k))
           zrfl(i) = zrfln
         END IF
@@ -836,5 +834,5 @@
   DO i = 1, klon
     IF (todo(i)) THEN
-      IF (zt(i,1)>rtt) THEN
+      IF (zt(i, 1)>rtt) THEN
         rain(i) = rain(i) + zrfl(i)
       ELSE
@@ -862,19 +860,19 @@
         IF (todo(i)) THEN
           IF (thermcep) THEN
-            zdelta = max(0., sign(1.,rtt-zt(i,k)))
-            zcvm5 = r5les*rlvtt*(1.-zdelta) + zdelta*r5ies*rlstt
-            zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*zq(i,k))
-            zqs(i, k) = r2es*foeew(zt(i,k), zdelta)/pplay(i, k)
-            zqs(i, k) = min(0.5, zqs(i,k))
-            zcor = 1./(1.-retv*zqs(i,k))
-            zqs(i, k) = zqs(i, k)*zcor
-            zdqs(i, k) = foede(zt(i,k), zdelta, zcvm5, zqs(i,k), zcor)
+            zdelta = max(0., sign(1., rtt - zt(i, k)))
+            zcvm5 = r5les * rlvtt * (1. - zdelta) + zdelta * r5ies * rlstt
+            zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * zq(i, k))
+            zqs(i, k) = r2es * foeew(zt(i, k), zdelta) / pplay(i, k)
+            zqs(i, k) = min(0.5, zqs(i, k))
+            zcor = 1. / (1. - retv * zqs(i, k))
+            zqs(i, k) = zqs(i, k) * zcor
+            zdqs(i, k) = foede(zt(i, k), zdelta, zcvm5, zqs(i, k), zcor)
           ELSE
-            IF (zt(i,k)<t_coup) THEN
-              zqs(i, k) = qsats(zt(i,k))/pplay(i, k)
-              zdqs(i, k) = dqsats(zt(i,k), zqs(i,k))
+            IF (zt(i, k)<t_coup) THEN
+              zqs(i, k) = qsats(zt(i, k)) / pplay(i, k)
+              zdqs(i, k) = dqsats(zt(i, k), zqs(i, k))
             ELSE
-              zqs(i, k) = qsatl(zt(i,k))/pplay(i, k)
-              zdqs(i, k) = dqsatl(zt(i,k), zqs(i,k))
+              zqs(i, k) = qsatl(zt(i, k)) / pplay(i, k)
+              zdqs(i, k) = dqsatl(zt(i, k), zqs(i, k))
             END IF
           END IF
@@ -888,9 +886,9 @@
       DO i = 1, klon
         IF (todo(i)) THEN
-          zgamdz(i, k) = -(pplay(i,k)-pplay(i,k+1))/paprs(i, k+1)/rcpd*(rd*( &
-            zt(i,k)*delp(i,k)+zt(i,k+1)*delp(i,k+1))/(delp(i,k)+delp(i, &
-            k+1))+rlvtt*(zqs(i,k)*delp(i,k)+zqs(i,k+1)*delp(i,k+1))/(delp(i, &
-            k)+delp(i,k+1)))/(1.0+(zdqs(i,k)*delp(i,k)+zdqs(i,k+1)*delp(i, &
-            k+1))/(delp(i,k)+delp(i,k+1)))
+          zgamdz(i, k) = -(pplay(i, k) - pplay(i, k + 1)) / paprs(i, k + 1) / rcpd * (rd * (&
+                  zt(i, k) * delp(i, k) + zt(i, k + 1) * delp(i, k + 1)) / (delp(i, k) + delp(i, &
+                  k + 1)) + rlvtt * (zqs(i, k) * delp(i, k) + zqs(i, k + 1) * delp(i, k + 1)) / (delp(i, &
+                  k) + delp(i, k + 1))) / (1.0 + (zdqs(i, k) * delp(i, k) + zdqs(i, k + 1) * delp(i, &
+                  k + 1)) / (delp(i, k) + delp(i, k + 1)))
         END IF
       END DO
@@ -903,5 +901,5 @@
     DO i = 1, klon
       IF (todo(i)) THEN
-        zqmqsdp(i, k) = (zq(i,k)-zqs(i,k))*delp(i, k)
+        zqmqsdp(i, k) = (zq(i, k) - zqs(i, k)) * delp(i, k)
       END IF
     END DO
@@ -916,8 +914,8 @@
   k1max = 1
   DO i = 1, klon
-    IF (todo(i) .AND. k1(i)>(kbase+1)) THEN
+    IF (todo(i) .AND. k1(i)>(kbase + 1)) THEN
       k = k1(i)
-      zflo(i) = zt(i, k-1) + zgamdz(i, k-1) - zt(i, k)
-      zsat(i) = zqmqsdp(i, k) + zqmqsdp(i, k-1)
+      zflo(i) = zt(i, k - 1) + zgamdz(i, k - 1) - zt(i, k)
+      zsat(i) = zqmqsdp(i, k) + zqmqsdp(i, k - 1)
       ! sc voici l'ancienne ligne:
       ! sc         IF (zflo(i).LE.0.0 .OR. zsat(i).LE.0.0) THEN
@@ -932,10 +930,10 @@
   END DO
 
-  IF (k1max>(kbase+1)) THEN
+  IF (k1max>(kbase + 1)) THEN
     DO k = k1max, kbase + 1, -1
       DO i = 1, klon
         IF (etendre(i) .AND. k<k1(i) .AND. aller(i)) THEN
           zsat(i) = zsat(i) + zqmqsdp(i, k)
-          zflo(i) = zt(i, k) + zgamdz(i, k) - zt(i, k+1)
+          zflo(i) = zt(i, k) + zgamdz(i, k) - zt(i, k + 1)
           IF (zsat(i)<=0.0 .OR. zflo(i)<=0.0) THEN
             aller(i) = .FALSE.
@@ -999,5 +997,5 @@
   ! a ajuster a partir du sommet de la colonne precedente
 
-860 CONTINUE ! Calculer les tendances et diagnostiques
+  860 CONTINUE ! Calculer les tendances et diagnostiques
   ! cc      PRINT*, "Apres 860"
 
@@ -1006,5 +1004,5 @@
       IF (accompli(i)) THEN
         d_t(i, k) = zt(i, k) - t(i, k)
-        zq(i, k) = max(zq(i,k), seuil_vap)
+        zq(i, k) = max(zq(i, k), seuil_vap)
         d_q(i, k) = zq(i, k) - q(i, k)
       END IF
@@ -1015,17 +1013,17 @@
     IF (accompli(i)) THEN
       DO k = 1, klev
-        IF (rneb(i,k)>0.0) THEN
+        IF (rneb(i, k)>0.0) THEN
           ibas(i) = k
           GO TO 807
         END IF
       END DO
-807   CONTINUE
+      807   CONTINUE
       DO k = klev, 1, -1
-        IF (rneb(i,k)>0.0) THEN
+        IF (rneb(i, k)>0.0) THEN
           itop(i) = k
           GO TO 808
         END IF
       END DO
-808   CONTINUE
+      808   CONTINUE
     END IF
   END DO
@@ -1041,9 +1039,11 @@
   END IF
 
-
 END SUBROUTINE conmanv
 SUBROUTINE conkuo(dtime, paprs, pplay, t, q, conv_q, d_t, d_q, d_ql, rneb, &
-    rain, snow, ibas, itop)
+        rain, snow, ibas, itop)
   USE dimphy
+  USE lmdz_YOETHF
+  USE lmdz_fcttre, ONLY: foeew, foede, qsats, qsatl, dqsats, dqsatl, thermcep
+
   IMPLICIT NONE
   ! ======================================================================
@@ -1058,5 +1058,5 @@
 
   REAL dtime ! intervalle du temps (s)
-  REAL paprs(klon, klev+1) ! pression a inter-couche (Pa)
+  REAL paprs(klon, klev + 1) ! pression a inter-couche (Pa)
   REAL pplay(klon, klev) ! pression au milieu de couche (Pa)
   REAL t(klon, klev) ! temperature (K)
@@ -1079,26 +1079,26 @@
 
   LOGICAL calcfcl ! calculer le niveau de convection libre
-  PARAMETER (calcfcl=.TRUE.)
+  PARAMETER (calcfcl = .TRUE.)
   INTEGER ldepar ! niveau fixe de convection libre
-  PARAMETER (ldepar=4)
+  PARAMETER (ldepar = 4)
   INTEGER opt_cld ! comment traiter l'eau liquide
-  PARAMETER (opt_cld=4) ! valeur possible: 0, 1, 2, 3 ou 4
+  PARAMETER (opt_cld = 4) ! valeur possible: 0, 1, 2, 3 ou 4
   LOGICAL evap_prec ! evaporation de pluie au-dessous de convection
-  PARAMETER (evap_prec=.TRUE.)
+  PARAMETER (evap_prec = .TRUE.)
   REAL coef_eva
-  PARAMETER (coef_eva=1.0E-05)
+  PARAMETER (coef_eva = 1.0E-05)
   LOGICAL new_deh ! nouvelle facon de calculer dH
-  PARAMETER (new_deh=.FALSE.)
+  PARAMETER (new_deh = .FALSE.)
   REAL t_coup
-  PARAMETER (t_coup=234.0)
+  PARAMETER (t_coup = 234.0)
   LOGICAL old_tau ! implique precipitation nulle
-  PARAMETER (old_tau=.FALSE.)
+  PARAMETER (old_tau = .FALSE.)
   REAL toliq(klon) ! rapport entre l'eau nuageuse et l'eau precipitante
   REAL dpmin, tomax !Epaisseur faible, rapport eau liquide plus grande
-  PARAMETER (dpmin=0.15, tomax=0.97)
+  PARAMETER (dpmin = 0.15, tomax = 0.97)
   REAL dpmax, tomin !Epaisseur grande, rapport eau liquide plus faible
-  PARAMETER (dpmax=0.30, tomin=0.05)
+  PARAMETER (dpmax = 0.30, tomin = 0.05)
   REAL deep_sig, deep_to ! au dela de deep_sig, utiliser deep_to
-  PARAMETER (deep_sig=0.50, deep_to=0.05)
+  PARAMETER (deep_sig = 0.50, deep_to = 0.05)
 
   ! Variables locales:
@@ -1129,7 +1129,4 @@
   ! Fonctions thermodynamiques
 
-  include "YOETHF.h"
-  include "FCTTRE.h"
-
   DATA appel1er/.TRUE./
 
@@ -1165,19 +1162,19 @@
     DO i = 1, klon
       IF (thermcep) THEN
-        zdelta = max(0., sign(1.,rtt-t(i,k)))
-        zcvm5 = r5les*rlvtt*(1.-zdelta) + zdelta*r5ies*rlstt
-        zcvm5 = zcvm5/rcpd/(1.0+rvtmp2*q(i,k))
-        zqs(i, k) = r2es*foeew(t(i,k), zdelta)/pplay(i, k)
-        zqs(i, k) = min(0.5, zqs(i,k))
-        zcor = 1./(1.-retv*zqs(i,k))
-        zqs(i, k) = zqs(i, k)*zcor
-        zdqs(i, k) = foede(t(i,k), zdelta, zcvm5, zqs(i,k), zcor)
+        zdelta = max(0., sign(1., rtt - t(i, k)))
+        zcvm5 = r5les * rlvtt * (1. - zdelta) + zdelta * r5ies * rlstt
+        zcvm5 = zcvm5 / rcpd / (1.0 + rvtmp2 * q(i, k))
+        zqs(i, k) = r2es * foeew(t(i, k), zdelta) / pplay(i, k)
+        zqs(i, k) = min(0.5, zqs(i, k))
+        zcor = 1. / (1. - retv * zqs(i, k))
+        zqs(i, k) = zqs(i, k) * zcor
+        zdqs(i, k) = foede(t(i, k), zdelta, zcvm5, zqs(i, k), zcor)
       ELSE
-        IF (t(i,k)<t_coup) THEN
-          zqs(i, k) = qsats(t(i,k))/pplay(i, k)
-          zdqs(i, k) = dqsats(t(i,k), zqs(i,k))
+        IF (t(i, k)<t_coup) THEN
+          zqs(i, k) = qsats(t(i, k)) / pplay(i, k)
+          zdqs(i, k) = dqsats(t(i, k), zqs(i, k))
         ELSE
-          zqs(i, k) = qsatl(t(i,k))/pplay(i, k)
-          zdqs(i, k) = dqsatl(t(i,k), zqs(i,k))
+          zqs(i, k) = qsatl(t(i, k)) / pplay(i, k)
+          zdqs(i, k) = dqsatl(t(i, k), zqs(i, k))
         END IF
       END IF
